;;; -*- coding: utf-8-unix -*-
;;;
;;;Part of: Vicare Scheme
;;;Contents: static platform inspection
;;;Date: Sat Jul 21, 2012
;;;
;;;Abstract
;;;
;;;
;;;
;;;Copyright (C) 2012 Marco Maggi <marco.maggi-ipsu@poste.it>
;;;
;;;This program is free software:  you can redistribute it and/or modify
;;;it under the terms of the  GNU General Public License as published by
;;;the Free Software Foundation, either version 3 of the License, or (at
;;;your option) any later version.
;;;
;;;This program is  distributed in the hope that it  will be useful, but
;;;WITHOUT  ANY   WARRANTY;  without   even  the  implied   warranty  of
;;;MERCHANTABILITY or  FITNESS FOR  A PARTICULAR  PURPOSE.  See  the GNU
;;;General Public License for more details.
;;;
;;;You should  have received a  copy of  the GNU General  Public License
;;;along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;;


#!r6rs
(library (vicare platform features)
  (export
    HAVE_ACCEPT
    HAVE_ACCESS
    HAVE_ACOSH
    HAVE_ALARM
    HAVE_ARPA_INET_H
    HAVE_ASINH
    HAVE_ASSERT_H
    HAVE_ATANH
    HAVE_BIND
    HAVE_CACOS
    HAVE_CACOSH
    HAVE_CASIN
    HAVE_CASINH
    HAVE_CATAN
    HAVE_CATANH
    HAVE_CCOS
    HAVE_CCOSH
    HAVE_CEXP
    HAVE_CHDIR
    HAVE_CHMOD
    HAVE_CHOWN
    HAVE_CLEARENV
    HAVE_CLOCK
    HAVE_CLOCK_GETCPUCLOCKID
    HAVE_CLOCK_GETRES
    HAVE_CLOCK_GETTIME
    HAVE_CLOCK_SETTIME
    HAVE_CLOG
    HAVE_CLOG10
    HAVE_CLOSE
    HAVE_CLOSEDIR
    HAVE_COMPLEX_H
    HAVE_CONFIG_H
    HAVE_CONFSTR
    HAVE_CONNECT
    HAVE_COSH
    HAVE_CPOW
    HAVE_CSIN
    HAVE_CSINH
    HAVE_CSQRT
    HAVE_CTAN
    HAVE_CTANH
    HAVE_CTERMID
    HAVE_DAEMON
    HAVE_DECL_ENVIRON
    HAVE_DIRENT_H
    HAVE_DIRFD
    HAVE_DUP
    HAVE_DUP2
    HAVE_ENDGRENT
    HAVE_ENDHOSTENT
    HAVE_ENDNETENT
    HAVE_ENDPROTOENT
    HAVE_ENDPWENT
    HAVE_ENDSERVENT
    HAVE_EPOLL_CREATE
    HAVE_EPOLL_CREATE1
    HAVE_EPOLL_CTL
    HAVE_EPOLL_WAIT
    HAVE_ERF
    HAVE_ERFC
    HAVE_ERRNO_H
    HAVE_EXECV
    HAVE_EXECVE
    HAVE_EXECVP
    HAVE_FCHDIR
    HAVE_FCHMOD
    HAVE_FCHOWN
    HAVE_FCNTL
    HAVE_FCNTL_H
    HAVE_FDATASYNC
    HAVE_FDOPENDIR
    HAVE_FNMATCH
    HAVE_FNMATCH_H
    HAVE_FORK
    HAVE_FPATHCONF
    HAVE_FSYNC
    HAVE_FTRUNCATE
    HAVE_FUTIMES
    HAVE_GAI_STRERROR
    HAVE_GETADDRINFO
    HAVE_GETCWD
    HAVE_GETEGID
    HAVE_GETENV
    HAVE_GETEUID
    HAVE_GETGID
    HAVE_GETGRENT
    HAVE_GETGRGID
    HAVE_GETGRNAM
    HAVE_GETGROUPS
    HAVE_GETHOSTBYADDR
    HAVE_GETHOSTBYNAME
    HAVE_GETHOSTBYNAME2
    HAVE_GETHOSTENT
    HAVE_GETITIMER
    HAVE_GETLOGIN
    HAVE_GETNETBYADDR
    HAVE_GETNETBYNAME
    HAVE_GETNETENT
    HAVE_GETPEERNAME
    HAVE_GETPGRP
    HAVE_GETPID
    HAVE_GETPPID
    HAVE_GETPROTOBYNAME
    HAVE_GETPROTOBYNUMBER
    HAVE_GETPROTOENT
    HAVE_GETPWENT
    HAVE_GETPWNAM
    HAVE_GETPWUID
    HAVE_GETRLIMIT
    HAVE_GETRUSAGE
    HAVE_GETSERVBYNAME
    HAVE_GETSERVBYPORT
    HAVE_GETSERVENT
    HAVE_GETSID
    HAVE_GETSOCKNAME
    HAVE_GETSOCKOPT
    HAVE_GETTIMEOFDAY
    HAVE_GETUID
    HAVE_GLOB
    HAVE_GLOB_H
    HAVE_GMTIME
    HAVE_GMTIME_R
    HAVE_GRP_H
    HAVE_HISTORY_H
    HAVE_ICONV
    HAVE_ICONV_CLOSE
    HAVE_ICONV_OPEN
    HAVE_IF_INDEXTONAME
    HAVE_IF_NAMEINDEX
    HAVE_IF_NAMETOINDEX
    HAVE_INET_ATON
    HAVE_INET_NTOA
    HAVE_INET_NTOP
    HAVE_INET_PTON
    HAVE_HTONL
    HAVE_HTONS
    HAVE_NTOHL
    HAVE_NTOHS
    HAVE_INOTIFY_ADD_WATCH
    HAVE_INOTIFY_INIT
    HAVE_INOTIFY_INIT1
    HAVE_INOTIFY_RM_WATCH
    HAVE_J0
    HAVE_J1
    HAVE_JN
    HAVE_HYPOT
    HAVE_CBRT
    HAVE_KILL
    HAVE_LGAMMA_R
    HAVE_LIBFFI
    HAVE_LIBICONV
    HAVE_LIBREADLINE
    HAVE_LIMITS_H
    HAVE_LINK
    HAVE_LISTEN
    HAVE_LOCKF
    HAVE_LOCALTIME_R
    HAVE_LSEEK
    HAVE_LSTAT
    HAVE_LUTIMES
    HAVE_MADVISE
    HAVE_MATH_H
    HAVE_MKDIR
    HAVE_MKDTEMP
    HAVE_MKFIFO
    HAVE_MKSTEMP
    HAVE_MKTIME
    HAVE_MLOCK
    HAVE_MLOCKALL
    HAVE_MMAP
    HAVE_MPROTECT
    HAVE_MQUEUE_H
    HAVE_MQ_CLOSE
    HAVE_MQ_GETATTR
    HAVE_MQ_OPEN
    HAVE_MQ_RECEIVE
    HAVE_MQ_SEND
    HAVE_MQ_SETATTR
    HAVE_MQ_TIMEDRECEIVE
    HAVE_MQ_TIMEDSEND
    HAVE_MQ_UNLINK
    HAVE_MREMAP
    HAVE_MSYNC
    HAVE_MUNLOCK
    HAVE_MUNLOCKALL
    HAVE_MUNMAP
    HAVE_NANOSLEEP
    HAVE_NETDB_H
    HAVE_NETINET_IN_H
    HAVE_NET_IF_H
    HAVE_OPEN
    HAVE_OPENDIR
    HAVE_PATHCONF
    HAVE_PAUSE
    HAVE_PIPE
    HAVE_POLL
    HAVE_POLL_H
    HAVE_PREAD
    HAVE_PRLIMIT
    HAVE_PWD_H
    HAVE_PWRITE
    HAVE_RAISE
    HAVE_RAND
    HAVE_READ
    HAVE_READDIR
    HAVE_READLINE_H
    HAVE_READLINE_HISTORY
    HAVE_READLINE_HISTORY_H
    HAVE_READLINE_READLINE_H
    HAVE_READLINK
    HAVE_READV
    HAVE_REALPATH
    HAVE_RECV
    HAVE_RECVFROM
    HAVE_REGCOMP
    HAVE_REGEX_H
    HAVE_REMOVE
    HAVE_RENAME
    HAVE_REWINDDIR
    HAVE_RMDIR
    HAVE_RUSAGE_RU_IDRSS
    HAVE_RUSAGE_RU_INBLOCK
    HAVE_RUSAGE_RU_ISRSS
    HAVE_RUSAGE_RU_IXRSS
    HAVE_RUSAGE_RU_MAJFLT
    HAVE_RUSAGE_RU_MAXRSS
    HAVE_RUSAGE_RU_MINFLT
    HAVE_RUSAGE_RU_MSGRCV
    HAVE_RUSAGE_RU_MSGSND
    HAVE_RUSAGE_RU_NIVCSW
    HAVE_RUSAGE_RU_NSIGNALS
    HAVE_RUSAGE_RU_NSWAP
    HAVE_RUSAGE_RU_NVCSW
    HAVE_RUSAGE_RU_OUBLOCK
    HAVE_RUSAGE_RU_STIME
    HAVE_RUSAGE_RU_UTIME
    HAVE_SEEKDIR
    HAVE_SELECT
    HAVE_SEMAPHORE_H
    HAVE_SEM_CLOSE
    HAVE_SEM_DESTROY
    HAVE_SEM_GETVALUE
    HAVE_SEM_INIT
    HAVE_SEM_OPEN
    HAVE_SEM_POST
    HAVE_SEM_TIMEDWAIT
    HAVE_SEM_TRYWAIT
    HAVE_SEM_UNLINK
    HAVE_SEM_WAIT
    HAVE_SEND
    HAVE_SENDTO
    HAVE_SETEGID
    HAVE_SETENV
    HAVE_SETEUID
    HAVE_SETGID
    HAVE_SETGRENT
    HAVE_SETHOSTENT
    HAVE_SETITIMER
    HAVE_SETNETENT
    HAVE_SETPGID
    HAVE_SETPROTOENT
    HAVE_SETPWENT
    HAVE_SETREGID
    HAVE_SETREUID
    HAVE_SETRLIMIT
    HAVE_SETSERVENT
    HAVE_SETSID
    HAVE_SETSOCKOPT
    HAVE_SETUID
    HAVE_SHM_OPEN
    HAVE_SHM_UNLINK
    HAVE_SHUTDOWN
    HAVE_SIGACTION
    HAVE_SIGADDSET
    HAVE_SIGALTSTACK
    HAVE_SIGEMPTYSET
    HAVE_SIGFILLSET
    HAVE_SIGINFO_SI_ADDR
    HAVE_SIGINFO_SI_ADDR_LSB
    HAVE_SIGINFO_SI_BAND
    HAVE_SIGINFO_SI_CODE
    HAVE_SIGINFO_SI_ERRNO
    HAVE_SIGINFO_SI_FD
    HAVE_SIGINFO_SI_INT
    HAVE_SIGINFO_SI_OVERRUN
    HAVE_SIGINFO_SI_PID
    HAVE_SIGINFO_SI_PTR
    HAVE_SIGINFO_SI_SIGNO
    HAVE_SIGINFO_SI_STATUS
    HAVE_SIGINFO_SI_STIME
    HAVE_SIGINFO_SI_TIMERID
    HAVE_SIGINFO_SI_TRAPNO
    HAVE_SIGINFO_SI_UID
    HAVE_SIGINFO_SI_UTIME
    HAVE_SIGINFO_SI_VALUE
    HAVE_SIGNALFD
    HAVE_SIGNAL_H
    HAVE_SIGPROCMASK
    HAVE_SIGTIMEDWAIT
    HAVE_SIGWAITINFO
    HAVE_SINH
    HAVE_SOCKET
    HAVE_SOCKETPAIR
    HAVE_STAT
    HAVE_STAT_ST_ATIM
    HAVE_STAT_ST_ATIMESPEC
    HAVE_STAT_ST_ATIME_USEC
    HAVE_STAT_ST_CTIM
    HAVE_STAT_ST_CTIMESPEC
    HAVE_STAT_ST_CTIME_USEC
    HAVE_STAT_ST_MTIM
    HAVE_STAT_ST_MTIMESPEC
    HAVE_STAT_ST_MTIME_USEC
    HAVE_STDARG_H
    HAVE_STDDEF_H
    HAVE_STDINT_H
    HAVE_STDIO_H
    HAVE_STDLIB_H
    HAVE_STRERROR
    HAVE_STRFTIME
    HAVE_STRINGS_H
    HAVE_STRING_H
    HAVE_STRUCT_ADDRINFO
    HAVE_STRUCT_EPOLL_EVENT
    HAVE_STRUCT_GROUP
    HAVE_STRUCT_HOSTENT
    HAVE_STRUCT_IN6_ADDR
    HAVE_STRUCT_NETENT
    HAVE_STRUCT_PASSWD
    HAVE_STRUCT_PROTOENT
    HAVE_STRUCT_SERVENT
    HAVE_STRUCT_SOCKADDR_IN
    HAVE_STRUCT_SOCKADDR_IN6
    HAVE_STRUCT_SOCKADDR_UN
    HAVE_STRUCT_TIMESPEC
    HAVE_STRUCT_TM
    HAVE_STRUCT_TMS
    HAVE_SYMLINK
    HAVE_SYNC
    HAVE_SYSCONF
    HAVE_SYSTEM
    HAVE_SYS_EPOLL_H
    HAVE_SYS_INOTIFY_H
    HAVE_SYS_IOCTL_H
    HAVE_SYS_MMAN_H
    HAVE_SYS_PARAM_H
    HAVE_SYS_RESOURCE_H
    HAVE_SYS_SIGNALFD_H
    HAVE_SYS_SOCKET_H
    HAVE_SYS_STAT_H
    HAVE_SYS_TIMERFD_H
    HAVE_SYS_TIMES_H
    HAVE_SYS_TIME_H
    HAVE_SYS_TYPES_H
    HAVE_SYS_UIO_H
    HAVE_SYS_UN_H
    HAVE_SYS_WAIT_H
    HAVE_TANH
    HAVE_TCGETPGRP
    HAVE_TCGETSID
    HAVE_TCSETPGRP
    HAVE_TELLDIR
    HAVE_TERMIOS_H
    HAVE_TGAMMA
    HAVE_TIME
    HAVE_TIMEGM
    HAVE_TIMELOCAL
    HAVE_TIMERFD_CREATE
    HAVE_TIMERFD_GETTIME
    HAVE_TIMERFD_SETTIME
    HAVE_TIMER_CREATE
    HAVE_TIMER_DELETE
    HAVE_TIMER_GETOVERRUN
    HAVE_TIMER_GETTIME
    HAVE_TIMER_SETTIME
    HAVE_TIMES
    HAVE_TIME_H
    HAVE_TRUNCATE
    HAVE_UMASK
    HAVE_UNAME
    HAVE_UNISTD_H
    HAVE_UNLINK
    HAVE_UNSETENV
    HAVE_UTIME
    HAVE_UTIMES
    HAVE_UTIME_H
    HAVE_WAIT
    HAVE_WAITID
    HAVE_WAITPID
    HAVE_WCOREDUMP
    HAVE_WEXITSTATUS
    HAVE_WIFCONTINUED
    HAVE_WIFEXITED
    HAVE_WIFSIGNALED
    HAVE_WIFSTOPPED
    HAVE_WORDEXP
    HAVE_WORDEXP_H
    HAVE_WRITE
    HAVE_WRITEV
    HAVE_WSTOPSIG
    HAVE_WTERMSIG
    HAVE_Y0
    HAVE_Y1
    HAVE_YN
    HAVE_FSTAT
    HAVE_IOCTL
    RL_READLINE_VERSION
    HAVE_IN_CLASSA
    HAVE_IN_CLASSB
    HAVE_IN_CLASSC
    HAVE_IN_CLASSD
    HAVE_IN_MULTICAST
    HAVE_IN_EXPERIMENTAL
    HAVE_IN_BADCLASS
    HAVE_IN6_IS_ADDR_UNSPECIFIED
    HAVE_IN6_IS_ADDR_LOOPBACK
    HAVE_IN6_IS_ADDR_LINKLOCAL
    HAVE_IN6_IS_ADDR_SITELOCAL
    HAVE_IN6_IS_ADDR_V4MAPPED
    HAVE_IN6_IS_ADDR_V4COMPAT
    HAVE_IN6_IS_ADDR_MULTICAST
    HAVE_IN6_IS_ADDR_MC_NODELOCAL
    HAVE_IN6_IS_ADDR_MC_LINKLOCAL
    HAVE_IN6_IS_ADDR_MC_SITELOCAL
    HAVE_IN6_IS_ADDR_MC_ORGLOCAL
    HAVE_IN6_IS_ADDR_MC_GLOBAL
    HAVE_IN6_ARE_ADDR_EQUAL
    HAVE_BINDRESVPORT
    HAVE_BINDRESVPORT6
    HAVE_ETHER_NTOA
    HAVE_ETHER_ATON
    HAVE_ETHER_NTOA_R
    HAVE_ETHER_ATON_R
    HAVE_ETHER_NTOHOST
    HAVE_ETHER_HOSTTON
    HAVE_ETHER_LINE
    )
  (import (rnrs))

;;;; helpers

(define-syntax define-inline-constant
  (syntax-rules ()
    ((_ ?name ?value)
     (define-syntax ?name (identifier-syntax ?value)))))


;;;; code

(define-inline-constant HAVE_ACCEPT #t)
(define-inline-constant HAVE_ACCESS #t)
(define-inline-constant HAVE_ACOSH #t)
(define-inline-constant HAVE_ALARM #t)
(define-inline-constant HAVE_ARPA_INET_H #t)
(define-inline-constant HAVE_ASINH #t)
(define-inline-constant HAVE_ASSERT_H #t)
(define-inline-constant HAVE_ATANH #t)
(define-inline-constant HAVE_BIND #t)
(define-inline-constant HAVE_CACOS #t)
(define-inline-constant HAVE_CACOSH #t)
(define-inline-constant HAVE_CASIN #t)
(define-inline-constant HAVE_CASINH #t)
(define-inline-constant HAVE_CATAN #t)
(define-inline-constant HAVE_CATANH #t)
(define-inline-constant HAVE_CCOS #t)
(define-inline-constant HAVE_CCOSH #t)
(define-inline-constant HAVE_CEXP #t)
(define-inline-constant HAVE_CHDIR #t)
(define-inline-constant HAVE_CHMOD #t)
(define-inline-constant HAVE_CHOWN #t)
(define-inline-constant HAVE_CLEARENV #t)
(define-inline-constant HAVE_CLOCK #t)
(define-inline-constant HAVE_CLOCK_GETCPUCLOCKID #t)
(define-inline-constant HAVE_CLOCK_GETRES #t)
(define-inline-constant HAVE_CLOCK_GETTIME #t)
(define-inline-constant HAVE_CLOCK_SETTIME #t)
(define-inline-constant HAVE_CLOG #t)
(define-inline-constant HAVE_CLOG10 #t)
(define-inline-constant HAVE_CLOSE #t)
(define-inline-constant HAVE_CLOSEDIR #t)
(define-inline-constant HAVE_COMPLEX_H #t)
(define-inline-constant HAVE_CONFIG_H #t)
(define-inline-constant HAVE_CONFSTR #t)
(define-inline-constant HAVE_CONNECT #t)
(define-inline-constant HAVE_COSH #t)
(define-inline-constant HAVE_CPOW #t)
(define-inline-constant HAVE_CSIN #t)
(define-inline-constant HAVE_CSINH #t)
(define-inline-constant HAVE_CSQRT #t)
(define-inline-constant HAVE_CTAN #t)
(define-inline-constant HAVE_CTANH #t)
(define-inline-constant HAVE_CTERMID #t)
(define-inline-constant HAVE_DAEMON #t)
(define-inline-constant HAVE_DECL_ENVIRON #t)
(define-inline-constant HAVE_DIRENT_H #t)
(define-inline-constant HAVE_DIRFD #t)
(define-inline-constant HAVE_DUP #t)
(define-inline-constant HAVE_DUP2 #t)
(define-inline-constant HAVE_ENDGRENT #t)
(define-inline-constant HAVE_ENDHOSTENT #t)
(define-inline-constant HAVE_ENDNETENT #t)
(define-inline-constant HAVE_ENDPROTOENT #t)
(define-inline-constant HAVE_ENDPWENT #t)
(define-inline-constant HAVE_ENDSERVENT #t)
(define-inline-constant HAVE_EPOLL_CREATE #t)
(define-inline-constant HAVE_EPOLL_CREATE1 #t)
(define-inline-constant HAVE_EPOLL_CTL #t)
(define-inline-constant HAVE_EPOLL_WAIT #t)
(define-inline-constant HAVE_ERF #t)
(define-inline-constant HAVE_ERFC #t)
(define-inline-constant HAVE_ERRNO_H #t)
(define-inline-constant HAVE_EXECV #t)
(define-inline-constant HAVE_EXECVE #t)
(define-inline-constant HAVE_EXECVP #t)
(define-inline-constant HAVE_FCHDIR #t)
(define-inline-constant HAVE_FCHMOD #t)
(define-inline-constant HAVE_FCHOWN #t)
(define-inline-constant HAVE_FCNTL #t)
(define-inline-constant HAVE_FCNTL_H #t)
(define-inline-constant HAVE_FDATASYNC #t)
(define-inline-constant HAVE_FDOPENDIR #t)
(define-inline-constant HAVE_FNMATCH #t)
(define-inline-constant HAVE_FNMATCH_H #t)
(define-inline-constant HAVE_FORK #t)
(define-inline-constant HAVE_FPATHCONF #t)
(define-inline-constant HAVE_FSYNC #t)
(define-inline-constant HAVE_FTRUNCATE #t)
(define-inline-constant HAVE_FUTIMES #t)
(define-inline-constant HAVE_GAI_STRERROR #t)
(define-inline-constant HAVE_GETADDRINFO #t)
(define-inline-constant HAVE_GETCWD #t)
(define-inline-constant HAVE_GETEGID #t)
(define-inline-constant HAVE_GETENV #t)
(define-inline-constant HAVE_GETEUID #t)
(define-inline-constant HAVE_GETGID #t)
(define-inline-constant HAVE_GETGRENT #t)
(define-inline-constant HAVE_GETGRGID #t)
(define-inline-constant HAVE_GETGRNAM #t)
(define-inline-constant HAVE_GETGROUPS #t)
(define-inline-constant HAVE_GETHOSTBYADDR #t)
(define-inline-constant HAVE_GETHOSTBYNAME #t)
(define-inline-constant HAVE_GETHOSTBYNAME2 #t)
(define-inline-constant HAVE_GETHOSTENT #t)
(define-inline-constant HAVE_GETITIMER #t)
(define-inline-constant HAVE_GETLOGIN #t)
(define-inline-constant HAVE_GETNETBYADDR #t)
(define-inline-constant HAVE_GETNETBYNAME #t)
(define-inline-constant HAVE_GETNETENT #t)
(define-inline-constant HAVE_GETPEERNAME #t)
(define-inline-constant HAVE_GETPGRP #t)
(define-inline-constant HAVE_GETPID #t)
(define-inline-constant HAVE_GETPPID #t)
(define-inline-constant HAVE_GETPROTOBYNAME #t)
(define-inline-constant HAVE_GETPROTOBYNUMBER #t)
(define-inline-constant HAVE_GETPROTOENT #t)
(define-inline-constant HAVE_GETPWENT #t)
(define-inline-constant HAVE_GETPWNAM #t)
(define-inline-constant HAVE_GETPWUID #t)
(define-inline-constant HAVE_GETRLIMIT #t)
(define-inline-constant HAVE_GETRUSAGE #t)
(define-inline-constant HAVE_GETSERVBYNAME #t)
(define-inline-constant HAVE_GETSERVBYPORT #t)
(define-inline-constant HAVE_GETSERVENT #t)
(define-inline-constant HAVE_GETSID #t)
(define-inline-constant HAVE_GETSOCKNAME #t)
(define-inline-constant HAVE_GETSOCKOPT #t)
(define-inline-constant HAVE_GETTIMEOFDAY #t)
(define-inline-constant HAVE_GETUID #t)
(define-inline-constant HAVE_GLOB #t)
(define-inline-constant HAVE_GLOB_H #t)
(define-inline-constant HAVE_GMTIME #f)
(define-inline-constant HAVE_GMTIME_R #t)
(define-inline-constant HAVE_GRP_H #t)
(define-inline-constant HAVE_HISTORY_H #f)
(define-inline-constant HAVE_ICONV #t)
(define-inline-constant HAVE_ICONV_CLOSE #f)
(define-inline-constant HAVE_ICONV_OPEN #f)
(define-inline-constant HAVE_IF_INDEXTONAME #t)
(define-inline-constant HAVE_IF_NAMEINDEX #t)
(define-inline-constant HAVE_IF_NAMETOINDEX #t)
(define-inline-constant HAVE_INET_ATON #t)
(define-inline-constant HAVE_INET_NTOA #t)
(define-inline-constant HAVE_INET_NTOP #t)
(define-inline-constant HAVE_INET_PTON #t)
(define-inline-constant HAVE_HTONL #t)
(define-inline-constant HAVE_HTONS #t)
(define-inline-constant HAVE_NTOHL #t)
(define-inline-constant HAVE_NTOHS #t)
(define-inline-constant HAVE_INOTIFY_ADD_WATCH #t)
(define-inline-constant HAVE_INOTIFY_INIT #t)
(define-inline-constant HAVE_INOTIFY_INIT1 #t)
(define-inline-constant HAVE_INOTIFY_RM_WATCH #t)
(define-inline-constant HAVE_J0 #t)
(define-inline-constant HAVE_J1 #t)
(define-inline-constant HAVE_JN #t)
(define-inline-constant HAVE_HYPOT #t)
(define-inline-constant HAVE_CBRT #t)
(define-inline-constant HAVE_KILL #t)
(define-inline-constant HAVE_LGAMMA_R #t)
(define-inline-constant HAVE_LIBFFI #t)
(define-inline-constant HAVE_LIBICONV #f)
(define-inline-constant HAVE_LIBREADLINE #t)
(define-inline-constant HAVE_LIMITS_H #t)
(define-inline-constant HAVE_LINK #t)
(define-inline-constant HAVE_LISTEN #t)
(define-inline-constant HAVE_LOCKF #t)
(define-inline-constant HAVE_LOCALTIME_R #t)
(define-inline-constant HAVE_LSEEK #t)
(define-inline-constant HAVE_LSTAT #t)
(define-inline-constant HAVE_LUTIMES #t)
(define-inline-constant HAVE_MADVISE #t)
(define-inline-constant HAVE_MATH_H #t)
(define-inline-constant HAVE_MKDIR #t)
(define-inline-constant HAVE_MKDTEMP #t)
(define-inline-constant HAVE_MKFIFO #t)
(define-inline-constant HAVE_MKSTEMP #t)
(define-inline-constant HAVE_MKTIME #t)
(define-inline-constant HAVE_MLOCK #t)
(define-inline-constant HAVE_MLOCKALL #t)
(define-inline-constant HAVE_MMAP #t)
(define-inline-constant HAVE_MPROTECT #t)
(define-inline-constant HAVE_MQUEUE_H #t)
(define-inline-constant HAVE_MQ_CLOSE #t)
(define-inline-constant HAVE_MQ_GETATTR #t)
(define-inline-constant HAVE_MQ_OPEN #t)
(define-inline-constant HAVE_MQ_RECEIVE #t)
(define-inline-constant HAVE_MQ_SEND #t)
(define-inline-constant HAVE_MQ_SETATTR #t)
(define-inline-constant HAVE_MQ_TIMEDRECEIVE #t)
(define-inline-constant HAVE_MQ_TIMEDSEND #t)
(define-inline-constant HAVE_MQ_UNLINK #t)
(define-inline-constant HAVE_MREMAP #t)
(define-inline-constant HAVE_MSYNC #t)
(define-inline-constant HAVE_MUNLOCK #t)
(define-inline-constant HAVE_MUNLOCKALL #t)
(define-inline-constant HAVE_MUNMAP #t)
(define-inline-constant HAVE_NANOSLEEP #t)
(define-inline-constant HAVE_NETDB_H #t)
(define-inline-constant HAVE_NETINET_IN_H #t)
(define-inline-constant HAVE_NET_IF_H #t)
(define-inline-constant HAVE_OPEN #t)
(define-inline-constant HAVE_OPENDIR #t)
(define-inline-constant HAVE_PATHCONF #t)
(define-inline-constant HAVE_PAUSE #t)
(define-inline-constant HAVE_PIPE #t)
(define-inline-constant HAVE_POLL #t)
(define-inline-constant HAVE_POLL_H #t)
(define-inline-constant HAVE_PREAD #t)
(define-inline-constant HAVE_PRLIMIT #t)
(define-inline-constant HAVE_PWD_H #t)
(define-inline-constant HAVE_PWRITE #t)
(define-inline-constant HAVE_RAISE #t)
(define-inline-constant HAVE_RAND #t)
(define-inline-constant HAVE_READ #t)
(define-inline-constant HAVE_READDIR #t)
(define-inline-constant HAVE_READLINE_H #f)
(define-inline-constant HAVE_READLINE_HISTORY #t)
(define-inline-constant HAVE_READLINE_HISTORY_H #t)
(define-inline-constant HAVE_READLINE_READLINE_H #t)
(define-inline-constant HAVE_READLINK #t)
(define-inline-constant HAVE_READV #t)
(define-inline-constant HAVE_REALPATH #t)
(define-inline-constant HAVE_RECV #t)
(define-inline-constant HAVE_RECVFROM #t)
(define-inline-constant HAVE_REGCOMP #t)
(define-inline-constant HAVE_REGEX_H #t)
(define-inline-constant HAVE_REMOVE #t)
(define-inline-constant HAVE_RENAME #t)
(define-inline-constant HAVE_REWINDDIR #t)
(define-inline-constant HAVE_RMDIR #t)
(define-inline-constant HAVE_RUSAGE_RU_IDRSS #t)
(define-inline-constant HAVE_RUSAGE_RU_INBLOCK #t)
(define-inline-constant HAVE_RUSAGE_RU_ISRSS #t)
(define-inline-constant HAVE_RUSAGE_RU_IXRSS #t)
(define-inline-constant HAVE_RUSAGE_RU_MAJFLT #t)
(define-inline-constant HAVE_RUSAGE_RU_MAXRSS #t)
(define-inline-constant HAVE_RUSAGE_RU_MINFLT #t)
(define-inline-constant HAVE_RUSAGE_RU_MSGRCV #t)
(define-inline-constant HAVE_RUSAGE_RU_MSGSND #t)
(define-inline-constant HAVE_RUSAGE_RU_NIVCSW #t)
(define-inline-constant HAVE_RUSAGE_RU_NSIGNALS #t)
(define-inline-constant HAVE_RUSAGE_RU_NSWAP #t)
(define-inline-constant HAVE_RUSAGE_RU_NVCSW #t)
(define-inline-constant HAVE_RUSAGE_RU_OUBLOCK #t)
(define-inline-constant HAVE_RUSAGE_RU_STIME #t)
(define-inline-constant HAVE_RUSAGE_RU_UTIME #t)
(define-inline-constant HAVE_SEEKDIR #t)
(define-inline-constant HAVE_SELECT #t)
(define-inline-constant HAVE_SEMAPHORE_H #t)
(define-inline-constant HAVE_SEM_CLOSE #t)
(define-inline-constant HAVE_SEM_DESTROY #t)
(define-inline-constant HAVE_SEM_GETVALUE #t)
(define-inline-constant HAVE_SEM_INIT #t)
(define-inline-constant HAVE_SEM_OPEN #t)
(define-inline-constant HAVE_SEM_POST #t)
(define-inline-constant HAVE_SEM_TIMEDWAIT #t)
(define-inline-constant HAVE_SEM_TRYWAIT #t)
(define-inline-constant HAVE_SEM_UNLINK #t)
(define-inline-constant HAVE_SEM_WAIT #t)
(define-inline-constant HAVE_SEND #t)
(define-inline-constant HAVE_SENDTO #t)
(define-inline-constant HAVE_SETEGID #t)
(define-inline-constant HAVE_SETENV #t)
(define-inline-constant HAVE_SETEUID #t)
(define-inline-constant HAVE_SETGID #t)
(define-inline-constant HAVE_SETGRENT #t)
(define-inline-constant HAVE_SETHOSTENT #t)
(define-inline-constant HAVE_SETITIMER #t)
(define-inline-constant HAVE_SETNETENT #t)
(define-inline-constant HAVE_SETPGID #t)
(define-inline-constant HAVE_SETPROTOENT #t)
(define-inline-constant HAVE_SETPWENT #t)
(define-inline-constant HAVE_SETREGID #t)
(define-inline-constant HAVE_SETREUID #t)
(define-inline-constant HAVE_SETRLIMIT #t)
(define-inline-constant HAVE_SETSERVENT #t)
(define-inline-constant HAVE_SETSID #t)
(define-inline-constant HAVE_SETSOCKOPT #t)
(define-inline-constant HAVE_SETUID #t)
(define-inline-constant HAVE_SHM_OPEN #t)
(define-inline-constant HAVE_SHM_UNLINK #t)
(define-inline-constant HAVE_SHUTDOWN #t)
(define-inline-constant HAVE_SIGACTION #t)
(define-inline-constant HAVE_SIGADDSET #t)
(define-inline-constant HAVE_SIGALTSTACK #t)
(define-inline-constant HAVE_SIGEMPTYSET #t)
(define-inline-constant HAVE_SIGFILLSET #t)
(define-inline-constant HAVE_SIGINFO_SI_ADDR #t)
(define-inline-constant HAVE_SIGINFO_SI_ADDR_LSB #t)
(define-inline-constant HAVE_SIGINFO_SI_BAND #t)
(define-inline-constant HAVE_SIGINFO_SI_CODE #t)
(define-inline-constant HAVE_SIGINFO_SI_ERRNO #t)
(define-inline-constant HAVE_SIGINFO_SI_FD #t)
(define-inline-constant HAVE_SIGINFO_SI_INT #t)
(define-inline-constant HAVE_SIGINFO_SI_OVERRUN #t)
(define-inline-constant HAVE_SIGINFO_SI_PID #t)
(define-inline-constant HAVE_SIGINFO_SI_PTR #t)
(define-inline-constant HAVE_SIGINFO_SI_SIGNO #t)
(define-inline-constant HAVE_SIGINFO_SI_STATUS #t)
(define-inline-constant HAVE_SIGINFO_SI_STIME #t)
(define-inline-constant HAVE_SIGINFO_SI_TIMERID #t)
(define-inline-constant HAVE_SIGINFO_SI_TRAPNO #f)
(define-inline-constant HAVE_SIGINFO_SI_UID #t)
(define-inline-constant HAVE_SIGINFO_SI_UTIME #t)
(define-inline-constant HAVE_SIGINFO_SI_VALUE #t)
(define-inline-constant HAVE_SIGNALFD #t)
(define-inline-constant HAVE_SIGNAL_H #t)
(define-inline-constant HAVE_SIGPROCMASK #t)
(define-inline-constant HAVE_SIGTIMEDWAIT #t)
(define-inline-constant HAVE_SIGWAITINFO #t)
(define-inline-constant HAVE_SINH #t)
(define-inline-constant HAVE_SOCKET #t)
(define-inline-constant HAVE_SOCKETPAIR #t)
(define-inline-constant HAVE_STAT #t)
(define-inline-constant HAVE_STAT_ST_ATIM #f)
(define-inline-constant HAVE_STAT_ST_ATIMESPEC #f)
(define-inline-constant HAVE_STAT_ST_ATIME_USEC #f)
(define-inline-constant HAVE_STAT_ST_CTIM #f)
(define-inline-constant HAVE_STAT_ST_CTIMESPEC #f)
(define-inline-constant HAVE_STAT_ST_CTIME_USEC #f)
(define-inline-constant HAVE_STAT_ST_MTIM #f)
(define-inline-constant HAVE_STAT_ST_MTIMESPEC #f)
(define-inline-constant HAVE_STAT_ST_MTIME_USEC #f)
(define-inline-constant HAVE_STDARG_H #t)
(define-inline-constant HAVE_STDDEF_H #t)
(define-inline-constant HAVE_STDINT_H #t)
(define-inline-constant HAVE_STDIO_H #f)
(define-inline-constant HAVE_STDLIB_H #t)
(define-inline-constant HAVE_STRERROR #t)
(define-inline-constant HAVE_STRFTIME #t)
(define-inline-constant HAVE_STRINGS_H #t)
(define-inline-constant HAVE_STRING_H #t)
(define-inline-constant HAVE_STRUCT_ADDRINFO #t)
(define-inline-constant HAVE_STRUCT_EPOLL_EVENT #t)
(define-inline-constant HAVE_STRUCT_GROUP #t)
(define-inline-constant HAVE_STRUCT_HOSTENT #t)
(define-inline-constant HAVE_STRUCT_IN6_ADDR #t)
(define-inline-constant HAVE_STRUCT_NETENT #t)
(define-inline-constant HAVE_STRUCT_PASSWD #t)
(define-inline-constant HAVE_STRUCT_PROTOENT #t)
(define-inline-constant HAVE_STRUCT_SERVENT #t)
(define-inline-constant HAVE_STRUCT_SOCKADDR_IN #t)
(define-inline-constant HAVE_STRUCT_SOCKADDR_IN6 #t)
(define-inline-constant HAVE_STRUCT_SOCKADDR_UN #t)
(define-inline-constant HAVE_STRUCT_TIMESPEC #t)
(define-inline-constant HAVE_STRUCT_TM #t)
(define-inline-constant HAVE_STRUCT_TMS #t)
(define-inline-constant HAVE_SYMLINK #t)
(define-inline-constant HAVE_SYNC #t)
(define-inline-constant HAVE_SYSCONF #t)
(define-inline-constant HAVE_SYSTEM #t)
(define-inline-constant HAVE_SYS_EPOLL_H #t)
(define-inline-constant HAVE_SYS_INOTIFY_H #t)
(define-inline-constant HAVE_SYS_IOCTL_H #t)
(define-inline-constant HAVE_SYS_MMAN_H #t)
(define-inline-constant HAVE_SYS_PARAM_H #t)
(define-inline-constant HAVE_SYS_RESOURCE_H #t)
(define-inline-constant HAVE_SYS_SIGNALFD_H #t)
(define-inline-constant HAVE_SYS_SOCKET_H #t)
(define-inline-constant HAVE_SYS_STAT_H #t)
(define-inline-constant HAVE_SYS_TIMERFD_H #t)
(define-inline-constant HAVE_SYS_TIMES_H #t)
(define-inline-constant HAVE_SYS_TIME_H #t)
(define-inline-constant HAVE_SYS_TYPES_H #t)
(define-inline-constant HAVE_SYS_UIO_H #t)
(define-inline-constant HAVE_SYS_UN_H #t)
(define-inline-constant HAVE_SYS_WAIT_H #t)
(define-inline-constant HAVE_TANH #t)
(define-inline-constant HAVE_TCGETPGRP #t)
(define-inline-constant HAVE_TCGETSID #t)
(define-inline-constant HAVE_TCSETPGRP #t)
(define-inline-constant HAVE_TELLDIR #t)
(define-inline-constant HAVE_TERMIOS_H #t)
(define-inline-constant HAVE_TGAMMA #t)
(define-inline-constant HAVE_TIME #t)
(define-inline-constant HAVE_TIMEGM #t)
(define-inline-constant HAVE_TIMELOCAL #t)
(define-inline-constant HAVE_TIMERFD_CREATE #t)
(define-inline-constant HAVE_TIMERFD_GETTIME #t)
(define-inline-constant HAVE_TIMERFD_SETTIME #t)
(define-inline-constant HAVE_TIMER_CREATE #t)
(define-inline-constant HAVE_TIMER_DELETE #t)
(define-inline-constant HAVE_TIMER_GETOVERRUN #t)
(define-inline-constant HAVE_TIMER_GETTIME #t)
(define-inline-constant HAVE_TIMER_SETTIME #t)
(define-inline-constant HAVE_TIMES #t)
(define-inline-constant HAVE_TIME_H #t)
(define-inline-constant HAVE_TRUNCATE #t)
(define-inline-constant HAVE_UMASK #t)
(define-inline-constant HAVE_UNAME #t)
(define-inline-constant HAVE_UNISTD_H #t)
(define-inline-constant HAVE_UNLINK #t)
(define-inline-constant HAVE_UNSETENV #t)
(define-inline-constant HAVE_UTIME #t)
(define-inline-constant HAVE_UTIMES #t)
(define-inline-constant HAVE_UTIME_H #t)
(define-inline-constant HAVE_WAIT #t)
(define-inline-constant HAVE_WAITID #t)
(define-inline-constant HAVE_WAITPID #t)
(define-inline-constant HAVE_WCOREDUMP #t)
(define-inline-constant HAVE_WEXITSTATUS #t)
(define-inline-constant HAVE_WIFCONTINUED #t)
(define-inline-constant HAVE_WIFEXITED #t)
(define-inline-constant HAVE_WIFSIGNALED #t)
(define-inline-constant HAVE_WIFSTOPPED #t)
(define-inline-constant HAVE_WORDEXP #t)
(define-inline-constant HAVE_WORDEXP_H #t)
(define-inline-constant HAVE_WRITE #t)
(define-inline-constant HAVE_WRITEV #t)
(define-inline-constant HAVE_WSTOPSIG #t)
(define-inline-constant HAVE_WTERMSIG #t)
(define-inline-constant HAVE_Y0 #t)
(define-inline-constant HAVE_Y1 #t)
(define-inline-constant HAVE_YN #t)
(define-inline-constant HAVE_FSTAT #t)
(define-inline-constant HAVE_IOCTL #t)
(define-inline-constant RL_READLINE_VERSION #f)
(define-inline-constant HAVE_IN_CLASSA #t)
(define-inline-constant HAVE_IN_CLASSB #t)
(define-inline-constant HAVE_IN_CLASSC #t)
(define-inline-constant HAVE_IN_CLASSD #t)
(define-inline-constant HAVE_IN_MULTICAST #t)
(define-inline-constant HAVE_IN_EXPERIMENTAL #t)
(define-inline-constant HAVE_IN_BADCLASS #t)
(define-inline-constant HAVE_IN6_IS_ADDR_UNSPECIFIED #t)
(define-inline-constant HAVE_IN6_IS_ADDR_LOOPBACK #t)
(define-inline-constant HAVE_IN6_IS_ADDR_LINKLOCAL #t)
(define-inline-constant HAVE_IN6_IS_ADDR_SITELOCAL #t)
(define-inline-constant HAVE_IN6_IS_ADDR_V4MAPPED #t)
(define-inline-constant HAVE_IN6_IS_ADDR_V4COMPAT #t)
(define-inline-constant HAVE_IN6_IS_ADDR_MULTICAST #t)
(define-inline-constant HAVE_IN6_IS_ADDR_MC_NODELOCAL #t)
(define-inline-constant HAVE_IN6_IS_ADDR_MC_LINKLOCAL #t)
(define-inline-constant HAVE_IN6_IS_ADDR_MC_SITELOCAL #t)
(define-inline-constant HAVE_IN6_IS_ADDR_MC_ORGLOCAL #t)
(define-inline-constant HAVE_IN6_IS_ADDR_MC_GLOBAL #t)
(define-inline-constant HAVE_IN6_ARE_ADDR_EQUAL #t)
(define-inline-constant HAVE_BINDRESVPORT #t)
(define-inline-constant HAVE_BINDRESVPORT6 #f)
(define-inline-constant HAVE_ETHER_NTOA #t)
(define-inline-constant HAVE_ETHER_ATON #t)
(define-inline-constant HAVE_ETHER_NTOA_R #t)
(define-inline-constant HAVE_ETHER_ATON_R #t)
(define-inline-constant HAVE_ETHER_NTOHOST #t)
(define-inline-constant HAVE_ETHER_HOSTTON #t)
(define-inline-constant HAVE_ETHER_LINE #t)

;;;; done

)

;;; end of file
